/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2008 Bull S.A.
 * Contact: jonas-team@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: $
 * --------------------------------------------------------------------------
 */
package org.ow2.jonas.lib.management.extensions.base;

import org.ow2.jonas.lib.management.tools.WhereAreYou;

/**
 * Base class for a JOnAS server management.
 * This class is extended by classes specialized for specific management aspects.
 * @author Adriana.Danes@bull.net
 * @author Oualaa Hani
 */
public class BaseManagement {
    /**
     * Current server name.
     */
    private String serverName = null;
    /**
     * Current domain name.
     */
    private String domainName = null;

    /**
     * Base constructor.
     */
    public BaseManagement() {
        serverName = WhereAreYou.getServerName();
        domainName = WhereAreYou.getDomainName();
    }

    /**
     * @return The current server name.
     */
    public String getServerName() {
        return serverName;
    }

    /**
     * @return The current domain name.
     */
    public String getDomainName() {
        return domainName;
    }
}
