; JOnAS: Java(TM) Open Application Server
; Copyright (C) 2003-2004 Bull S.A.
; Contact: jonas-team@objectweb.org
;
; This library is free software; you can redistribute it and/or
; modify it under the terms of the GNU Lesser General Public
; License as published by the Free Software Foundation; either
; version 2.1 of the License, or any later version.
;
; This library is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
; Lesser General Public License for more details.
;
; You should have received a copy of the GNU Lesser General Public
; License along with this library; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
; USA
;
; --------------------------------------------------------------------------
; $Id: jonas-tomcat.nsi,v 1.1 2003/10/24 14:44:54 benoitf Exp $
; --------------------------------------------------------------------------

;JOnAS win32 installer
;Written by Florent Benoit
; Use the Modern UI (NSIS Modern User Interface version 1.72)
;Add two custom page :
; - one for choosing the JAVA_HOME
; - one for ant/bcel.jar installation

; updated to work with NSIS 2.0.3 (12/12/2004)
; So you should use this version to be sure :)

;Based upon the examples provided by NSIS written by Joost Verburg
; @Attributes@ are replaced by ant script

; JOnAS product and directories
!define PRODUCT "JOnAS"
!define WEBCONTAINER "@WEBCONTAINER@"
!define WEBCONTAINER_VERSION "@WEBCONTAINER_VERSION@"
!define VERSION "@JONAS_VERSION@"
!define JONAS_DIR "@WORKING_DIRECTORY@\@JONAS_UNPACKED_DIRECTORY@"
!define ANT_DIR "@WORKING_DIRECTORY@\@ANT_UNPACKED_DIRECTORY@"
!define BCEL_DIR "@WORKING_DIRECTORY@\@BCEL_UNPACKED_DIRECTORY@"
!define HEADER_JONAS "@WORKING_DIRECTORY@\modern-header-jonas.bmp"
!define PRODUCT_ORG "ObjectWeb"
!define MUI_ICON "@WORKING_DIRECTORY@\jonas.ico"
!define MUI_UNICON "@WORKING_DIRECTORY@\jonas.ico"


;--------------------
!include "MUI.nsh"
;--------------------------------
;Configuration

  ;General
 !define FULL_PRODUCT_NAME "@MUI_PRODUCT@"
  BrandingText "${PRODUCT_ORG} ${PRODUCT}"
  Name "${FULL_PRODUCT_NAME}"
  OutFile "@OUTFILE@"

  ;Folder selection page
  InstallDir "C:\${PRODUCT}-${VERSION}"

  ;Start Menu Folder Page Configuration
  !define MUI_STARTMENUPAGE_REGISTRY_ROOT "HKCU"
  !define MUI_STARTMENUPAGE_REGISTRY_KEY "Software\${PRODUCT}"
  !define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "${PRODUCT}"

  ;Ddefault folder for start menu
  !define MUI_STARTMENUPAGE_DEFAULTFOLDER "${PRODUCT}"

  ; For uninstalling with Control panel
  !define UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\JOnAS"

  ; Type of installation
  InstType            "Typical"
  InstType            "Full"
  InstType            "Minimal"
  ShowInstDetails show



; Compress
;------------
SetCompress          auto
SetCompressor        lzma
SetDatablockOptimize on
SetDateSave          on

;--------------------------------
;Variables
  Var STARTMENU_FOLDER
  Var MUI_TEMP
;--------------------------------
;Modern UI Configuration
  !define MUI_CUSTOMPAGECOMMANDS
  !define MUI_HEADERIMAGE
  !define MUI_HEADERIMAGE_BITMAP ${HEADER_JONAS}

  !define MUI_WELCOMEPAGE
  !define MUI_LICENSEPAGE
  !define MUI_COMPONENTSPAGE
  !define MUI_COMPONENTSPAGE_SMALLDESC
  !define MUI_DIRECTORYPAGE
  !define MUI_CUSTOMFUNCTION_DIRECTORY_LEAVE checkDirectory
  !define MUI_STARTMENUPAGE
  !define MUI_FINISHPAGE
    !define MUI_FINISHPAGE_SHOWREADME "$INSTDIR/ReleaseNotes.txt"
    !define MUI_FINISHPAGE_NOAUTOCLOSE
  !define MUI_ABORTWARNING

  !define MUI_UNINSTALLER
  !define MUI_UNCONFIRMPAGE


;--------------------------------
;Pages Define our own pages

  !insertmacro MUI_PAGE_WELCOME
  !insertmacro MUI_PAGE_LICENSE "${JONAS_DIR}\LicenceAgreement.txt"
  ; First is after the licence
  Page custom SetJavaPage
  Page custom SetAntPage
  !insertmacro MUI_PAGE_COMPONENTS
  !define MUI_PAGE_CUSTOMFUNCTION_LEAVE checkDirectory
  !insertmacro MUI_PAGE_DIRECTORY
  !insertmacro MUI_PAGE_STARTMENU Application $STARTMENU_FOLDER

  !insertmacro MUI_PAGE_INSTFILES
  !insertmacro MUI_PAGE_FINISH

;--------------------------------
;Languages
  !insertmacro MUI_LANGUAGE "English"
;--------------------------------
;Language Strings

  ;Description
  LangString DESC_CoreUI ${LANG_ENGLISH} "Copy all the required binaries and libraries, web container,... in order to run JOnAS"
  LangString DESC_Documentation1UI ${LANG_ENGLISH} "Copy the user's manual including a getting started"
  LangString DESC_Documentation2UI ${LANG_ENGLISH} "Copy the javadoc of the JOnAS server"
  LangString DESC_ExamplesUI ${LANG_ENGLISH} "Copy the examples of JOnAS including ear, ejbjars, etc."
  LangString DESC_JonasBaseUI ${LANG_ENGLISH} "Copy an example of JONAS_BASE directory. Allow to use JOnAS with different configurations"

  LangString TEXT_IO_JAVATITLE ${LANG_ENGLISH} "Java Setup"
  LangString TEXT_IO_JAVASUBTITLE ${LANG_ENGLISH} "Java Development Kit"

  LangString TEXT_IO_ANTTITLE ${LANG_ENGLISH} "Ant Setup"
  LangString TEXT_IO_ANTSUBTITLE ${LANG_ENGLISH} "Ant compiler"

;--------------------------------
;Reserve Files

  ;Things that need to be extracted on first (keep these lines before any File command!)
  ;Only useful for compression
  ReserveFile "javapage.ini"
  ReserveFile "antpage.ini"
  ReserveFile "${JONAS_DIR}\LicenceAgreement.txt"
  ReserveFile ${HEADER_JONAS}
  !insertmacro MUI_RESERVEFILE_INSTALLOPTIONS


;--------------------------------
;Installer Sections

Section "!Core" CoreUI
SectionIn 1 2 3 RO

SetOverwrite try
SetOutPath $INSTDIR

;Licence, Readme, install.html...
File  ${JONAS_DIR}\*
;apps
File /r ${JONAS_DIR}\apps
;bin
File /r ${JONAS_DIR}\bin
;clients
File /r ${JONAS_DIR}\clients
;conf
File /r ${JONAS_DIR}\conf
;ejbjars
File /r ${JONAS_DIR}\ejbjars
;lib
File /r ${JONAS_DIR}\lib
;logs
File /r ${JONAS_DIR}\logs
;rars
File /r ${JONAS_DIR}\rars
;templates
File /r ${JONAS_DIR}\templates
;webapps
File /r ${JONAS_DIR}\webapps
;xml
File /r ${JONAS_DIR}\xml

; icon
File ${MUI_ICON}

   ; Write JOnAS ROOT
   WriteRegStr HKCU "Environment" "JONAS_ROOT" $INSTDIR
   ; Add to path bin
   push "%JONAS_ROOT%\bin\nt"
   Call AddToPath

   ; Write JAVA_HOME
   ReadINIStr $2 "$PLUGINSDIR\javapage.ini" "Field 9" "State"
   WriteRegStr HKCU "Environment" "JAVA_HOME" $2

  push "%JAVA_HOME%\bin"
  Call AddToPath

    ;Create shortcuts
    CreateDirectory "$SMPROGRAMS\$STARTMENU_FOLDER"
    CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\Start JOnAS (ForeGround).lnk" "$INSTDIR\bin\nt\jonas.bat" "start -fg"
    CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\Start JOnAS (BackGround).lnk" "$INSTDIR\bin\nt\jonas.bat" "start"
    CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\Stop JOnAS.lnk" "$INSTDIR\bin\nt\jonas.bat" "stop"
    CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\JOnAS Documentation.lnk" "$INSTDIR\webapps\autoload\jonas-doc-en\index.html"
    CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\JOnAS JavaDoc.lnk" "$INSTDIR\webapps\autoload\jonas-javadoc\index.html"
    CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\Root context (Startup page).lnk" "http://localhost:9000/"
    CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\JOnASAdmin.lnk" "http://localhost:9000/jonasAdmin"
    CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\JOnAS Home Page.lnk" "http://jonas.objectweb.org/"
    CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\Uninstall JOnAS.lnk" "$INSTDIR\Uninstall.exe"



  ;Create uninstaller
  WriteRegStr HKLM ${UNINST_KEY} DisplayName "${PRODUCT} ${VERSION}"
  WriteRegStr HKLM ${UNINST_KEY} DisplayVersion "${VERSION}"
  WriteRegStr HKLM ${UNINST_KEY} DisplayIcon "$INSTDIR\jonas.ico"
  WriteRegStr HKLM ${UNINST_KEY} UninstallString "$INSTDIR\Uninstall.exe"
  WriteUninstaller "$INSTDIR\Uninstall.exe"



SectionEnd

Section "Examples" ExamplesUI
SectionIn 1 2
SetOverwrite try
SetOutPath $INSTDIR

;examples
File /r ${JONAS_DIR}\examples

SectionEnd

@DEMOSERVER@

Section "-Ant"
  SectionIn 1 2 3

  ;Checkbox is disabled ? nothing to do
  ReadINIStr $1 "$PLUGINSDIR\antpage.ini" "Field 10" "Flags"
  StrCmp $1 DISABLED noAnt


  ;Checkbox is checked ?
  ReadINIStr $1 "$PLUGINSDIR\antpage.ini" "Field 10" "State"
  StrCmp $1 0 noAnt

  ;Checkbox is checked so install ant
  ;Ant
  SetOverwrite try
  SetOutPath $INSTDIR\ant
  WriteINIStr "$PLUGINSDIR\antpage.ini" "Field 4" "State" $INSTDIR\ant

  WriteRegStr HKCU "Environment" "ANT_HOME" $INSTDIR\ant
  ;Ant
  File ${ANT_DIR}\*
  File /r ${ANT_DIR}\bin
  File /r ${ANT_DIR}\etc
  File /r ${ANT_DIR}\lib


  push "%ANT_HOME%\bin"
  Call AddToPath


  noAnt:
SectionEnd

Section "-Bcel"
  SectionIn 1 2 3

  ;Checkbox is disabled ? nothing to do
  ReadINIStr $1 "$PLUGINSDIR\antpage.ini" "Field 11" "Flags"
  StrCmp $1 DISABLED noBCel

  ;Checkbox is checked ?
  ReadINIStr $1 "$PLUGINSDIR\antpage.ini" "Field 11" "State"
  StrCmp $1 0 noBcel

  ;It is checked
  ;Bcel
  SetOverwrite try

  ; Right path
  ReadINIStr $1 "$PLUGINSDIR\antpage.ini" "Field 10" "State"
  StrCmp $1 DISABLED defaultPath
  ; install to ANT_HOME\lib
  ReadINIStr $1 "$PLUGINSDIR\antpage.ini" "Field 4" "State"
  SetOutPath $1\lib
  goto pathSet

  ;install to default path
  defaultPath:
  SetOutPath $INSTDIR\ant\lib

  pathSet:
  File ${BCEL_DIR}\bcel-5.1.jar

  noBcel:
SectionEnd



;--------------------------------
;Descriptions
!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${CoreUI} $(DESC_CoreUI)
  !insertmacro MUI_DESCRIPTION_TEXT ${Documentation1UI} $(DESC_Documentation1UI)
  !insertmacro MUI_DESCRIPTION_TEXT ${Documentation2UI} $(DESC_Documentation2UI)
  !insertmacro MUI_DESCRIPTION_TEXT ${ExamplesUI} $(DESC_ExamplesUI)
  !insertmacro MUI_DESCRIPTION_TEXT ${JonasBaseUI} $(DESC_JonasBaseUI)

!insertmacro MUI_FUNCTION_DESCRIPTION_END



;--------------------------------
;Installer Functions

Function .onInit

  Call IsNT
  Pop $1
  StrCmp $1 1 NTInstall
   MessageBox MB_OK|MB_ICONSTOP "JOnAS scripts don't run on Win 9x systems. So this setup will exit."
   Abort

  NTInstall:
  ;Extract InstallOptions INI Files
  !insertmacro MUI_INSTALLOPTIONS_EXTRACT "javapage.ini"
  !insertmacro MUI_INSTALLOPTIONS_EXTRACT "antpage.ini"

FunctionEnd


Function SetJavaPage
  call GetJavaVersion
  StrCmp $1 "" javaNotFound javaFound
  javaNotFound:
   MessageBox MB_OK|MB_ICONSTOP "No J2SE SDK/JDK was found on this computer. No JAVA_HOME is defined and no Sun J2SE SDK/JDK is installed. Please download a J2SE SDK/JDK from the Sun Microsystems site at http://java.sun.com/j2se. Please launch again this setup when you will have install a J2SE SDK/JDK."
   ; Launch a browser to the Sun site before exiting
   ExecShell open http://java.sun.com/j2se/1.4.2/download.html
   Quit
  javaFound:
  !insertmacro MUI_HEADER_TEXT "$(TEXT_IO_JAVATITLE)" "$(TEXT_IO_JAVASUBTITLE)"
  !insertmacro MUI_INSTALLOPTIONS_DISPLAY "javapage.ini"
FunctionEnd


Function SetAntPage
  call GetAnt
  !insertmacro MUI_HEADER_TEXT "$(TEXT_IO_ANTTITLE)" "$(TEXT_IO_ANTSUBTITLE)"
  !insertmacro MUI_INSTALLOPTIONS_DISPLAY "antpage.ini"
FunctionEnd

Function checkDirectory
Push $INSTDIR
Call CheckForSpaces
Pop $1
IntCmp $1 0 noSpaces
MessageBox MB_OK|MB_ICONEXCLAMATION "Error: The Installaton directory has $1 spaces.$\nYou cannot have spaces in the directory path."
Abort

noSpaces:
FunctionEnd

Function GetJavaVersion

  ;No value by default
  StrCpy $5 ""

  ClearErrors
  ; READ JAVA_HOME from all users
  ReadEnvStr $1 "JAVA_HOME"
  IfErrors noAllUsersJavaHome
  StrCpy $5 $1
  ; Set the JAVA_HOME value into the ini file
  WriteINIStr "$PLUGINSDIR\javapage.ini" "Field 4" "State" $5
  ; Add item to combo
  WriteINIStr "$PLUGINSDIR\javapage.ini" "Field 9" "State" $5
  WriteINIStr "$PLUGINSDIR\javapage.ini" "Field 9" "ListItems" $5

  noAllUsersJavaHome:
  ClearErrors
  ; READ JAVA_HOME from the user
  ReadRegStr $1 HKCU "Environment" "JAVA_HOME"
  IfErrors noUserJavaHome
  StrCpy $5 $1
  ; Set the JAVA_HOME value into the ini file
  WriteINIStr "$PLUGINSDIR\javapage.ini" "Field 4" "State" $5
  ; Add item to combo
  WriteINIStr "$PLUGINSDIR\javapage.ini" "Field 9" "State" $5
  WriteINIStr "$PLUGINSDIR\javapage.ini" "Field 9" "ListItems" $5


  noUserJavaHome:
  ClearErrors
  ; Read the Sun JDK value from the registry
  ReadRegStr $3 HKLM "SOFTWARE\JavaSoft\Java Development Kit" "CurrentVersion"
  ReadRegStr $4 HKLM "SOFTWARE\JavaSoft\Java Development Kit\$3" "JavaHome"

  IfErrors noSunJDK
  StrCpy $5 $4
  WriteINIStr "$PLUGINSDIR\javapage.ini" "Field 7" "State" $5
  ; Read item from combo
  ReadINIStr $6 "$PLUGINSDIR\javapage.ini" "Field 9" "State"
  ; same value, don't add
  StrCmp $6 $5 noSunJDK
  ; add or append to existing value ?
  StrCmp $5 "" setJDK appendJDK
  setJDK:
  WriteINIStr "$PLUGINSDIR\javapage.ini" "Field 9" "State" $6
  WriteINIStr "$PLUGINSDIR\javapage.ini" "Field 9" "ListItems" $6
  goto noSunJDK
  appendJDK:
  WriteINIStr "$PLUGINSDIR\javapage.ini" "Field 9" "ListItems" $6|$5



  noSunJDK:
  StrCpy $1 $5

FunctionEnd



Function GetAnt
  ;No value by default
  StrCpy $1 ""
  StrCpy $2 ""

  ClearErrors
  ; READ ANT_HOME from all users
  ReadEnvStr $1 "ANT_HOME"
  IfErrors noAllUsersAntHome
  ; Set the ANT_HOME value into the ini file
  WriteINIStr "$PLUGINSDIR\antpage.ini" "Field 4" "State" $1
  WriteINIStr "$PLUGINSDIR\antpage.ini" "Field 10" "Flags" DISABLED
  StrCpy $2 $1

  noAllUsersAntHome:
  ClearErrors
  ; READ ANT_HOME from the user
  ReadRegStr $1 HKCU "Environment" "ANT_HOME"
  IfErrors noUserAntHome
  ; Set the ANT_HOME value into the ini file
  WriteINIStr "$PLUGINSDIR\antpage.ini" "Field 4" "State" $1
  WriteINIStr "$PLUGINSDIR\antpage.ini" "Field 10" "Flags" DISABLED
  StrCpy $2 $1

  noUserAntHome:
  ClearErrors
  ReadINIStr $1 "$PLUGINSDIR\antpage.ini" "Field 4" "State"
  StrCmp $2 "" noAnt
  ; check if there is a bcel.jar file in ANT_HOME\lib
  ReadINIStr $2 "$PLUGINSDIR\antpage.ini" "Field 4" "State"
  IfFileExists $2\lib\bcel-5.1.jar 0 noBcel
  WriteINIStr "$PLUGINSDIR\antpage.ini" "Field 7" "State" Yes
  WriteINIStr "$PLUGINSDIR\antpage.ini" "Field 11" "Flags" DISABLED

  noAnt:
  noBcel:

FunctionEnd





; Script written by KiCHiK
; modified by Florent Benoit : add to the path only if the path doesn't already exists
; do not modify for windows 9x with autoexec.bat
; Put path before the existing path
; Use WriteRegExpandStr instead of WriteRegStr (for %VAR% path)
!verbose 3
!include "WinMessages.nsh"
!verbose 4

;====================================================
; AddToPath - Adds the given dir to the search path.
;        Input - head of the stack
;====================================================
Function AddToPath
  Exch $0
  Push $1

  ReadRegStr $1 HKCU "Environment" "PATH"

  ;Add to path only if the path is not present
  Push $1
  Push $0
  Call StrStr ; Find $0 in $1
  ;Copy path that we want to add into $2
  StrCpy $2 $0
  Pop $0 ; pos of our dir
  ; not found = -1
  IntCmp $0 -1 AddingPath
  goto PathAlreadyAdded
  AddingPath:
    StrCmp $1 "" AddToPath_NTdoIt
    StrCpy $2 "$2;$1"
  AddToPath_NTdoIt:
    WriteRegExpandStr HKCU "Environment" "PATH" $2

  PathAlreadyAdded:
   SendMessage ${HWND_BROADCAST} ${WM_WININICHANGE} 0 "STR:Environment" /TIMEOUT=5000
    Pop $1
    Pop $0
FunctionEnd

;====================================================
; RemoveFromPath - Remove a given dir from the path
;     Input: head of the stack
;====================================================
Function un.RemoveFromPath
  Exch $0
  Push $1
  Push $2
  Push $3
  Push $4

    StrLen $2 $0
    ReadRegStr $1 HKCU "Environment" "PATH"
    Push $1
    Push $0
    Call un.StrStr ; Find $0 in $1
    Pop $0 ; pos of our dir
    IntCmp $0 -1 unRemoveFromPath_done
      ; else, it is in path
      StrCpy $3 $1 $0 ; $3 now has the part of the path before our dir
      IntOp $2 $2 + $0 ; $2 now contains the pos after our dir in the path (';')
      IntOp $2 $2 + 1 ; $2 now containts the pos after our dir and the semicolon.
      StrLen $0 $1
      StrCpy $1 $1 $0 $2
      StrCpy $3 "$3$1"

      WriteRegStr HKCU "Environment" "PATH" $3
      SendMessage ${HWND_BROADCAST} ${WM_WININICHANGE} 0 "STR:Environment" /TIMEOUT=5000

  unRemoveFromPath_done:
    Pop $4
    Pop $3
    Pop $2
    Pop $1
    Pop $0
FunctionEnd

;====================================================
; IsNT - Returns 1 if the current system is NT, 0
;        otherwise.
;     Output: head of the stack
;====================================================
Function IsNT
  Push $0
  ReadRegStr $0 HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion" CurrentVersion
  StrCmp $0 "" 0 IsNT_yes
  ; we are not NT.
  Pop $0
  Push 0
  Return

  IsNT_yes:
    ; NT!!!
    Pop $0
    Push 1
FunctionEnd

;====================================================
; StrStr - Finds a given string in another given string.
;               Returns -1 if not found and the pos if found.
;          Input: head of the stack - string to find
;                      second in the stack - string to find in
;          Output: head of the stack
;====================================================
Function StrStr
  Push $0
  Exch
  Pop $0 ; $0 now have the string to find
  Push $1
  Exch 2
  Pop $1 ; $1 now have the string to find in
  Exch
  Push $2
  Push $3
  Push $4
  Push $5

  StrCpy $2 -1
  StrLen $3 $0
  StrLen $4 $1
  IntOp $4 $4 - $3

  unStrStr_loop:
    IntOp $2 $2 + 1
    IntCmp $2 $4 0 0 unStrStrReturn_notFound
    StrCpy $5 $1 $3 $2
    StrCmp $5 $0 unStrStr_done unStrStr_loop

  unStrStrReturn_notFound:
    StrCpy $2 -1

  unStrStr_done:
    Pop $5
    Pop $4
    Pop $3
    Exch $2
    Exch 2
    Pop $0
    Pop $1
FunctionEnd

; written by Afrow UK (http://nsis.sourceforge.net/archive/nsisweb.php?page=222)
Function CheckForSpaces
 Exch $R0
 Push $R1
 Push $R2
 Push $R3
 Push $R4
 StrCpy $R1 -1
 StrCpy $R3 0
 StrCpy $R4 ""
 StrCpy $R5 ""
 loop:
   StrCpy $R2 $R0 1 $R1
   IntOp $R1 $R1 - 1
   StrCmp $R2 "" done
   StrCmp $R2 " " found
   StrCpy $R4 "$R2$R4"
 Goto loop
 found:
   IntOp $R3 $R3 + 1
 Goto loop
 done:
StrCpy $1 $R3
push $1
;   MessageBox MB_OK|MB_ICONEXCLAMATION "Error: The Installaton directory has $R3 spaces.$\nYou cannot have spaces in the directory path."
;   Pop $R3
;   Pop $R2
;   Pop $R1
;   Exch $R3
FunctionEnd

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Uninstall sutff
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Function un.StrStr
  Push $0
  Exch
  Pop $0 ; $0 now have the string to find
  Push $1
  Exch 2
  Pop $1 ; $1 now have the string to find in
  Exch
  Push $2
  Push $3
  Push $4
  Push $5

  StrCpy $2 -1
  StrLen $3 $0
  StrLen $4 $1
  IntOp $4 $4 - $3

  unStrStr_loop:
    IntOp $2 $2 + 1
    IntCmp $2 $4 0 0 unStrStrReturn_notFound
    StrCpy $5 $1 $3 $2
    StrCmp $5 $0 unStrStr_done unStrStr_loop

  unStrStrReturn_notFound:
    StrCpy $2 -1

  unStrStr_done:
    Pop $5
    Pop $4
    Pop $3
    Exch $2
    Exch 2
    Pop $0
    Pop $1
FunctionEnd

;--------------------------------
;Uninstaller Section

Section "Uninstall"

  MessageBox MB_YESNO|MB_ICONINFORMATION "It will remove all files of $INSTDIR directory" IDNO noRemove

  ;Get start menu folder to remove links
  !insertmacro MUI_STARTMENU_GETFOLDER Application $MUI_TEMP

  ;Delete start menu folder
  StrCpy $MUI_TEMP "$SMPROGRAMS\$MUI_TEMP"
  Delete "$MUI_TEMP\*.lnk"
  RMDir $MUI_TEMP

  ;delete env var and registry keys
  DeleteRegKey /ifempty HKCU "Software\${PRODUCT}"
  DeleteRegKey HKLM ${UNINST_KEY}
  DeleteRegValue HKCU "Environment" "JONAS_ROOT"

  ; ant packaged
  IfFileExists $INSTDIR\ant\*.* removeAnt dontRemoveAnt
  removeAnt:
  DeleteRegValue HKCU "Environment" "ANT_HOME"
  RMDir /r "$INSTDIR\ant"
  push "%ANT_HOME%\bin"
  Call un.RemoveFromPath


  dontRemoveAnt:
  push "%JONAS_ROOT%\bin\nt"
  Call un.RemoveFromPath

  Delete $INSTDIR\Uninstall.exe
  RMDir /r "$INSTDIR"

  noRemove:
SectionEnd
